﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Xml.Linq; //<---

namespace XML
{
    internal static class PrzechowywanieGeometriiOkna
    {
        private const string nazwaPliku = "okno.xml";

        public static void ZapiszGeometrię(this Window okno)
        {
            XDocument xml = new XDocument(
                new XDeclaration("1.0", "utf-8", "yes"),
                new XComment("Data utworzenia: " + DateTime.Now.ToString()),
                new XElement("okno",
                    new XAttribute("nazwa", okno.Title),
                    new XElement("rozmiar",
                        new XElement("w", okno.Width),
                        new XElement("h", okno.Height)
                    ),
                    new XElement("położenie",
                        new XAttribute("x", okno.Left),
                        new XAttribute("y", okno.Top)
                    )
                )
            );
            xml.Save(nazwaPliku);
        }

        public static void ZastosujUstawieniaZPlikuXML(Window okno)
        {
            if (!System.IO.File.Exists(nazwaPliku)) return;

            try
            {
                XDocument xml = XDocument.Load(nazwaPliku);
                if (xml.Root.Attributes().Any(a => a.Name == "nazwa"))
                    okno.Title = xml.Root.Attribute("nazwa").Value;
                okno.Width = double.Parse(xml.Root.Element("rozmiar").Element("w").Value);
                okno.Height = double.Parse(xml.Root.Element("rozmiar").Element("h").Value);
                okno.Left = double.Parse(xml.Root.Element("położenie").Attribute("x").Value);
                okno.Top = double.Parse(xml.Root.Element("położenie").Attribute("y").Value);
            }
            catch (IOException exc)
            {
                MessageBox.Show("Problem z plikiem: " + exc.Message, okno.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
            catch (Exception exc)
            {
                MessageBox.Show("Inny wyjątek, być może z parsowaniem", okno.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
    }
}
